## ros-one-rosx-introspection 2.0.1-1jammy.20251023.0215

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

project(rosx_introspection LANGUAGES CXX VERSION 1.0.2)

# create compile_commands.json
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

option(CMAKE_POSITION_INDEPENDENT_CODE "Set -fPIC" ON)
option(ROSX_PYTHON_BINDINGS "Build Python bindings using nanobind" OFF)
option(ROSX_HAS_JSON "Add JSON converters" ON)

include(cmake/CPM.cmake)

find_package(ament_cmake QUIET)

if (ament_cmake_FOUND)
    set(USING_ROS2 TRUE)
    find_package(rosbag2_cpp REQUIRED)
    find_package(ament_index_cpp REQUIRED)
    find_package(rclcpp REQUIRED)

    set(EXTRA_SRC
       src/ros_utils/message_definition_cache.cpp
       src/ros_utils/ros2_helpers.cpp)
endif()


###############################################
## Declare a C++ library
###############################################
add_library(rosx_introspection
    ${SRC_FILES}
    src/ros_type.cpp
    src/ros_field.cpp
    src/stringtree_leaf.cpp
    src/ros_message.cpp
    src/ros_parser.cpp
    src/deserializer.cpp
    src/serializer.cpp
    ${EXTRA_SRC}
    )

target_include_directories(rosx_introspection PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>)
target_compile_features(rosx_introspection PUBLIC cxx_std_17)

if(USING_ROS2)
    target_link_libraries(rosx_introspection PUBLIC
        ament_index_cpp::ament_index_cpp
        rclcpp::rclcpp
        rosbag2_cpp::rosbag2_cpp
    )
endif()

if(ROSX_HAS_JSON)
    find_package(RapidJSON QUIET)

    if(NOT RapidJSON_FOUND)
        message(STATUS "Downloading RapidJSON with CPM")
        CPMAddPackage(NAME rapidjson
            GIT_TAG v1.1.0
            GITHUB_REPOSITORY "Tencent/rapidjson"
            OPTIONS "RAPIDJSON_BUILD_EXAMPLES OFF" "RAPIDJSON_BUILD_TESTS OFF" "RAPIDJSON_BUILD_DOC OFF")
    endif()

    target_compile_definitions(rosx_introspection PRIVATE ROSX_HAS_JSON)
    if(NOT USING_ROS2)
        target_link_libraries(rosx_introspection PRIVATE rapidjson)
    endif()

endif(ROSX_HAS_JSON)


###############################################
## Install and Tests
###############################################
if(BUILD_TESTING)
    if(USING_ROS2)
        find_package(sensor_msgs REQUIRED)
        find_package(geometry_msgs REQUIRED)
        find_package(ament_cmake_gtest REQUIRED)

        ament_add_gtest(rosx_introspection_test
            test/test_parser.cpp
            test/test_ros2.cpp )

        target_link_libraries(rosx_introspection PUBLIC
            ${sensor_msgs_TARGETS}
            ${geometry_msgs_TARGETS}
            )
        target_link_libraries(rosx_introspection_test rosx_introspection)

        target_include_directories(rosx_introspection_test PUBLIC
                $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>)
    endif(USING_ROS2)

    find_package(GTest REQUIRED)

    add_executable(parser_test
            test/test_parser.cpp
            test/test_encoding.cpp)

    target_link_libraries(parser_test rosx_introspection GTest::GTest GTest::Main)
    target_include_directories(parser_test PUBLIC
                $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>)

endif(BUILD_TESTING)


if(USING_ROS2)
    ament_export_targets(rosx_introspectionTargets HAS_LIBRARY_TARGET)
    ament_export_dependencies(ament_index_cpp rosbag2_cpp)
    ament_package()
endif(USING_ROS2)

include(GNUInstallDirs)
install(
    DIRECTORY include/
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
)
install(TARGETS rosx_introspection
    EXPORT rosx_introspectionTargets
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
)

# Python bindings
if(ROSX_PYTHON_BINDINGS)
    add_subdirectory(python)
endif()

=== python/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)
project(rosx_introspection_python)

# Find Python
find_package(Python 3.8
  REQUIRED COMPONENTS Interpreter Development.Module
  OPTIONAL_COMPONENTS Development.SABIModule)

# Fetch nanobind via CPM
CPMAddPackage(
  NAME            nanobind
  GITHUB_REPOSITORY wjakob/nanobind
  GIT_TAG         v2.9.2
)

# Create the Python module
nanobind_add_module(
  rosx_introspection_py
  STABLE_ABI
  NB_STATIC  # Build static for better portability
  rosx_introspection_py.cpp
)

# Link with the main rosx_introspection library
target_link_libraries(rosx_introspection_py PRIVATE rosx_introspection)

# Set properties
set_target_properties(rosx_introspection_py PROPERTIES
  CXX_STANDARD 17
  CXX_STANDARD_REQUIRED ON
  OUTPUT_NAME "rosx_introspection"  # This makes the .so file have the right name
)

# Determine installation directory
# When building with scikit-build-core, use relative paths
# Otherwise, use the system Python site-packages
if(DEFINED SKBUILD)
  set(ROSX_INSTALL_DIR "rosx_introspection")
else()
  set(ROSX_INSTALL_DIR "${Python_SITEARCH}/rosx_introspection")
endif()

# Install the Python module
install(TARGETS rosx_introspection_py
  LIBRARY DESTINATION ${ROSX_INSTALL_DIR})

# Create __init__.py
file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/__init__.py"
"\"\"\"ROS X Introspection - Python bindings for ROS message parsing.\"\"\"

from .rosx_introspection import Parser

__version__ = '1.0.0'
__all__ = ['Parser', 'parse_ros_message']
")

# Install __init__.py
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/__init__.py"
  DESTINATION ${ROSX_INSTALL_DIR})

=== debian/changelog ===
ros-one-rosx-introspection (2.0.1-1jammy.20251023.0215) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Davide Faconti <davide.faconti@gmail.com>  Thu, 23 Oct 2025 02:15:44 +0000

ros-one-rosx-introspection (2.0.1-0jammy) jammy; urgency=high

  * Merge pull request #21 <https://github.com/facontidavide/rosx_introspection/issues/21> from bryzhao/fix/scikit-build-core-compatibility
    Fix CMakeLists to support scikit-build-core installations
  * Fix CMakeLists to support scikit-build-core installations
  * Merge pull request #20 <https://github.com/facontidavide/rosx_introspection/issues/20> from nealtanner/bugfix/mac-compliation
    fix compilation errors on mac
  * replace sprintf with snprintf
  * inline vs constexpr
  * Contributors: Bryan Zhao, Davide Faconti, Neal Tanner

 -- Davide Faconti <davide.faconti@gmail.com>  Wed, 01 Oct 2025 00:00:00 -0000

ros-one-rosx-introspection (2.0.0-0jammy) jammy; urgency=high

  * optionally remove JSON support
  * new formatting
  * fix memory and add README
  * add python binding
  * NanoCDR
  * Merge pull request #16 <https://github.com/facontidavide/rosx_introspection/issues/16> from traversaro/patch-1
    Add missing include of functional header in message_definition_cache.cpp
  * Fix issue #13 <https://github.com/facontidavide/rosx_introspection/issues/13>
  * Merge pull request #11 <https://github.com/facontidavide/rosx_introspection/issues/11> from valgur/bugfix/clang
    Fix ros_parser.cpp compilation failures on Clang
  * Contributors: Davide Faconti, Martin Valgur, Silvio Traversaro

 -- Davide Faconti <davide.faconti@gmail.com>  Wed, 24 Sep 2025 00:00:00 -0000

ros-one-rosx-introspection (1.0.2-0jammy) jammy; urgency=high

  * bug fix
  * add unit tests
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Sun, 28 Jul 2024 00:00:00 -0000

ros-one-rosx-introspection (1.0.1-0jammy) jammy; urgency=high

  * use CPM to download dependenies
  * Merge pull request #9 <https://github.com/facontidavide/rosx_introspection/issues/9> from valgur/feature/cmake-improvements
  * Contributors: Davide Faconti, Martin Valgur

 -- Davide Faconti <davide.faconti@gmail.com>  Sat, 29 Jun 2024 00:00:00 -0000

ros-one-rosx-introspection (1.0.0-0jammy) jammy; urgency=high

  * New version including JSON conversion
  * Contributors: Basavaraj-PN, Davide Faconti, ahmad-ra

 -- Davide Faconti <davide.faconti@gmail.com>  Wed, 26 Jun 2024 00:00:00 -0000

=== debian/control ===
Source: ros-one-rosx-introspection
Section: misc
Priority: optional
Maintainer: Davide Faconti <davide.faconti@gmail.com>
Build-Depends: debhelper (>= 9.0.0), rapidjson-dev, ros-one-catkin, ros-one-roscpp, ros-one-roscpp-serialization
Homepage: 
Standards-Version: 3.9.2

Package: ros-one-rosx-introspection
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, rapidjson-dev, ros-one-roscpp, ros-one-roscpp-serialization
Description: Parse any ROS/ROS2 message without compile-time information

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/one/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_configure -- \
		-DFETCHCONTENT_FULLY_DISCONNECTED=OFF \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/one" \
		-DCMAKE_PREFIX_PATH="/opt/ros/one" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-one-rosx-introspection//opt/ros/one/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_install

## ros-one-rosx-introspection 2.0.1-1noble.20251023.0213

=== debian/changelog ===
ros-one-rosx-introspection (2.0.1-1noble.20251023.0213) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Davide Faconti <davide.faconti@gmail.com>  Thu, 23 Oct 2025 02:13:58 +0000

ros-one-rosx-introspection (2.0.1-0noble) noble; urgency=high

  * Merge pull request #21 <https://github.com/facontidavide/rosx_introspection/issues/21> from bryzhao/fix/scikit-build-core-compatibility
    Fix CMakeLists to support scikit-build-core installations
  * Fix CMakeLists to support scikit-build-core installations
  * Merge pull request #20 <https://github.com/facontidavide/rosx_introspection/issues/20> from nealtanner/bugfix/mac-compliation
    fix compilation errors on mac
  * replace sprintf with snprintf
  * inline vs constexpr
  * Contributors: Bryan Zhao, Davide Faconti, Neal Tanner

 -- Davide Faconti <davide.faconti@gmail.com>  Wed, 01 Oct 2025 00:00:00 -0000

ros-one-rosx-introspection (2.0.0-0noble) noble; urgency=high

  * optionally remove JSON support
  * new formatting
  * fix memory and add README
  * add python binding
  * NanoCDR
  * Merge pull request #16 <https://github.com/facontidavide/rosx_introspection/issues/16> from traversaro/patch-1
    Add missing include of functional header in message_definition_cache.cpp
  * Fix issue #13 <https://github.com/facontidavide/rosx_introspection/issues/13>
  * Merge pull request #11 <https://github.com/facontidavide/rosx_introspection/issues/11> from valgur/bugfix/clang
    Fix ros_parser.cpp compilation failures on Clang
  * Contributors: Davide Faconti, Martin Valgur, Silvio Traversaro

 -- Davide Faconti <davide.faconti@gmail.com>  Wed, 24 Sep 2025 00:00:00 -0000

ros-one-rosx-introspection (1.0.2-0noble) noble; urgency=high

  * bug fix
  * add unit tests
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Sun, 28 Jul 2024 00:00:00 -0000

ros-one-rosx-introspection (1.0.1-0noble) noble; urgency=high

  * use CPM to download dependenies
  * Merge pull request #9 <https://github.com/facontidavide/rosx_introspection/issues/9> from valgur/feature/cmake-improvements
  * Contributors: Davide Faconti, Martin Valgur

 -- Davide Faconti <davide.faconti@gmail.com>  Sat, 29 Jun 2024 00:00:00 -0000

ros-one-rosx-introspection (1.0.0-0noble) noble; urgency=high

  * New version including JSON conversion
  * Contributors: Basavaraj-PN, Davide Faconti, ahmad-ra

 -- Davide Faconti <davide.faconti@gmail.com>  Wed, 26 Jun 2024 00:00:00 -0000

## ros-one-rosx-introspection 2.1.0-0jammy.20260222.2052

=== debian/changelog ===
ros-one-rosx-introspection (2.1.0-0jammy.20260222.2052) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Davide Faconti <davide.faconti@gmail.com>  Sun, 22 Feb 2026 20:52:03 +0000

ros-one-rosx-introspection (2.1.0-0jammy) jammy; urgency=high

  * Fix multiple bugs in serialization, deserialization, and JSON handling
    - Fix missing throw in ROS_Deserializer::deserialize for unsupported types
    - Fix NanoCDR_Deserializer::deserializeByteSequence crash on empty sequences
    - Fix ROS_Serializer buffer resize logic and UB (const-cast, type-punning)
    - Fix Tree::find using &_root instead of _root.get() on unique_ptr
    - Fix msgpack pointer invalidation after vector resize for large messages
    - Fix blob detection in deserialize() (was restricted to OTHER type only)
    - Fix deserializeIntoJson blob skip not advancing the deserializer
    - Fix serializeFromJson: add JSON parse error checking, type-safe value
    reading with range validation, proper null handling for missing fields
    - Add complete ROS_Serializer implementation (serialize, serializeString, etc.)
    - Add comprehensive test coverage for all fixes
    Co-Authored-By: Claude Opus 4.6 <noreply@anthropic.com>
  * Merge pull request #29 <https://github.com/facontidavide/rosx_introspection//issues/29> from agxeed/fix/time-duration-nsec-serialization
    fix: correct nsecs duration serialization
  * Merge pull request #22 <https://github.com/facontidavide/rosx_introspection//issues/22> from amarburg/bugfix_ament_export_testing_dependencies
    Add sensor_msgs, geometry_msgs as ament dependencies when BUILD_TESTING is true
  * Merge pull request #27 <https://github.com/facontidavide/rosx_introspection//issues/27> from jorritolthuis/msgpack_cpp
    Make convertToMsgPack() available in C++
  * Merge pull request #30 <https://github.com/facontidavide/rosx_introspection//issues/30> from agxeed/fix/compiler-warnings
    fix: compiler warnings
  * Merge pull request #32 <https://github.com/facontidavide/rosx_introspection//issues/32> from konsim83/feature/replace_rosbag2_cpp_with_rclcpp
    Use rclcpp type support instead of rosbag2_cpp
  * fix: compiler warnings
  * fix: correct nsecs duration serialization
  * Make convertToMsgPack() available in C++
  * Add sensor_msgs, geometry_msgs as ament dependencies when BUILD_TESTING
  * remove ament_target_dependencies
  * Contributors: Davide Faconti, Jorrit Olthuis, Konrad Simon, Rein Appeldoorn, admin

 -- Davide Faconti <davide.faconti@gmail.com>  Sat, 21 Feb 2026 00:00:00 -0000

## ros-one-rosx-introspection 2.1.0-0noble.20260222.2051

=== CMakeLists.txt ===
--- 
+++ 
@@ -37,6 +37,7 @@
     src/ros_parser.cpp
     src/deserializer.cpp
     src/serializer.cpp
+    src/msgpack_utils.cpp
     ${EXTRA_SRC}
     )
 
@@ -66,7 +67,11 @@
 
     target_compile_definitions(rosx_introspection PRIVATE ROSX_HAS_JSON)
     if(NOT USING_ROS2)
-        target_link_libraries(rosx_introspection PRIVATE rapidjson)
+        if(TARGET rapidjson)
+            target_link_libraries(rosx_introspection PRIVATE rapidjson)
+        elseif(RapidJSON_INCLUDE_DIRS)
+            target_include_directories(rosx_introspection PRIVATE ${RapidJSON_INCLUDE_DIRS})
+        endif()
     endif()
 
 endif(ROSX_HAS_JSON)
@@ -80,6 +85,8 @@
         find_package(sensor_msgs REQUIRED)
         find_package(geometry_msgs REQUIRED)
         find_package(ament_cmake_gtest REQUIRED)
+
+        set(TESTING_DEPENDENCIES sensor_msgs geometry_msgs)
 
         ament_add_gtest(rosx_introspection_test
             test/test_parser.cpp
@@ -110,7 +117,7 @@
 
 if(USING_ROS2)
     ament_export_targets(rosx_introspectionTargets HAS_LIBRARY_TARGET)
-    ament_export_dependencies(ament_index_cpp rosbag2_cpp)
+    ament_export_dependencies(ament_index_cpp rosbag2_cpp ${TESTING_DEPENDENCIES})
     ament_package()
 endif(USING_ROS2)

=== debian/changelog ===
ros-one-rosx-introspection (2.1.0-0noble.20260222.2051) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Davide Faconti <davide.faconti@gmail.com>  Sun, 22 Feb 2026 20:51:27 +0000

ros-one-rosx-introspection (2.1.0-0noble) noble; urgency=high

  * Fix multiple bugs in serialization, deserialization, and JSON handling
    - Fix missing throw in ROS_Deserializer::deserialize for unsupported types
    - Fix NanoCDR_Deserializer::deserializeByteSequence crash on empty sequences
    - Fix ROS_Serializer buffer resize logic and UB (const-cast, type-punning)
    - Fix Tree::find using &_root instead of _root.get() on unique_ptr
    - Fix msgpack pointer invalidation after vector resize for large messages
    - Fix blob detection in deserialize() (was restricted to OTHER type only)
    - Fix deserializeIntoJson blob skip not advancing the deserializer
    - Fix serializeFromJson: add JSON parse error checking, type-safe value
    reading with range validation, proper null handling for missing fields
    - Add complete ROS_Serializer implementation (serialize, serializeString, etc.)
    - Add comprehensive test coverage for all fixes
    Co-Authored-By: Claude Opus 4.6 <noreply@anthropic.com>
  * Merge pull request #29 <https://github.com/facontidavide/rosx_introspection//issues/29> from agxeed/fix/time-duration-nsec-serialization
    fix: correct nsecs duration serialization
  * Merge pull request #22 <https://github.com/facontidavide/rosx_introspection//issues/22> from amarburg/bugfix_ament_export_testing_dependencies
    Add sensor_msgs, geometry_msgs as ament dependencies when BUILD_TESTING is true
  * Merge pull request #27 <https://github.com/facontidavide/rosx_introspection//issues/27> from jorritolthuis/msgpack_cpp
    Make convertToMsgPack() available in C++
  * Merge pull request #30 <https://github.com/facontidavide/rosx_introspection//issues/30> from agxeed/fix/compiler-warnings
    fix: compiler warnings
  * Merge pull request #32 <https://github.com/facontidavide/rosx_introspection//issues/32> from konsim83/feature/replace_rosbag2_cpp_with_rclcpp
    Use rclcpp type support instead of rosbag2_cpp
  * fix: compiler warnings
  * fix: correct nsecs duration serialization
  * Make convertToMsgPack() available in C++
  * Add sensor_msgs, geometry_msgs as ament dependencies when BUILD_TESTING
  * remove ament_target_dependencies
  * Contributors: Davide Faconti, Jorrit Olthuis, Konrad Simon, Rein Appeldoorn, admin

 -- Davide Faconti <davide.faconti@gmail.com>  Sat, 21 Feb 2026 00:00:00 -0000
